/*******************************************************************

Part of the Fritzing project - http://fritzing.org
Copyright (c) 2007-2010 Fachhochschule Potsdam - http://fh-potsdam.de

Fritzing is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fritzing is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Fritzing.  If not, see <http://www.gnu.org/licenses/>.

********************************************************************

$Revision: 4260 $:
$Author: cohen@irascible.com $:
$Date: 2010-06-15 15:56:01 +0200 (Tue, 15 Jun 2010) $

********************************************************************/

#ifndef VIA_H
#define VIA_H

#include "hole.h"

class Via : public Hole 
{
	Q_OBJECT

public:
	Via(ModelPart *, ViewIdentifierClass::ViewIdentifier, const ViewGeometry & viewGeometry, long id, QMenu * itemMenu, bool doLabel);
	~Via();

protected:
	void setBoth(const QString & holeDiameter, const QString &  thickness);
	QString makeID();
	QPointF ringThicknessRange();
	QPointF holeDiameterRange();
	static void setBothConnectors(ItemBase * itemBase, SvgIdLayer * svgIdLayer);


};

#endif
